'use strict';

var _ = require('lodash');
var yaml = require('js-yaml');
var React = require('react');
var ReactDOM = require('react-dom');
var ReactDOMServer = require('react-dom/server');

var Configure = require('./components/Configure');
var configureFactory = React.createFactory(Configure);

module.exports.Configure = Configure;

module.exports.renderYml = function (yml, container, opts) {
  var doc = yaml.safeLoad(yml);
  var props = _.defaults({ groups: doc.config }, opts);
  var element = configureFactory(props);
  ReactDOM.render(element, container);
};

module.exports.renderYmlToString = function (yml, cb, opts) {
  var doc;
  try {
    doc = yaml.safeLoad(yml);
  } catch (exc) {
    cb(exc, null);
    return;
  }
  var props = _.defaults({ groups: doc.config }, opts);
  var element = configureFactory(props);
  var html = ReactDOMServer.renderToString(element);
  cb(null, html);
};
//# sourceMappingURL=index.js.map
